#ifndef bqtDimDefHH
#define bqtDimDefHH

#include <utility>
#include <vector>

#include "expr.hh"

class dimindexdef
{
    // lower, upper
    std::vector<std::pair<exprp, exprp> > indices;
public:
    dimindexdef(expr *l, expr *u)
    {
    	indices.push_back(std::make_pair(l, u));
    }
    dimindexdef(expr *u)
    {
    	expr *l = NULL; // FIXME: option base here.
    	indices.push_back(std::make_pair(l, u));
    }
    
    bool is_const() const
    {
        for(unsigned a=0; a<indices.size(); ++a)
            if(!indices[a].first->is_const()
            || !indices[a].second->is_const()) return false;
        return true;
    }
	
	void set_as(dimindexdef *b)
	{
		indices.insert(indices.end(), b->indices.begin(), b->indices.end());
		delete b;
	}
};

#endif
